﻿-- =========================================================
-- Settings
set BU to 3 -- Second to back up prior to the click to start of clip

--  Name of play list in iTunes for the clips to be added
set NAC to "#NA-Clips"

-- True to include Show number in clip name  
--NOT USED YET
--set ShowNum to true

-- True to include Show number in clip name 
--NOT USED YET
--set ShowTitle to true

-- Test for playlist  Create if needed
tell application "iTunes"
	if not (exists playlist NAC) then
		make new playlist with properties {name:NAC}
	end if
end tell
-- =========================================================
-- Main Loop
-- =========================================================

set Butt to 1
set But1 to "Start"
set ClipMessage to "Start Marker"
repeat
	
	set question to display dialog ClipMessage buttons {But1, "Cancel"} default button Butt
	set answer to button returned of question
	tell application "iTunes" to set (T) to player position
	set T to T - BU
	tell application "iTunes" to set ShowNumber to name of current track
	if answer = "Cancel" then quit
	set Clip to answer & " " & T
	
	if answer = "Start" then
		set Butt to 2
		set But1 to "Stop"
		set ClipMessage to "Recording"
	end if
	if answer = "Stop" then
		set Butt to 1
		set But1 to "Start"
		set ClipMessage to "Start Marker"
		tell application "iTunes" to set FinPos to player position
		tell application "iTunes" to pause
		
		set ClipName to display dialog ("name for Clip") default answer "Clip"
		set ClipName2 to text returned of ClipName
		set ClipName to ClipName & ".mp3"
		set result to Clipper(T, FinPos, ClipName2, NAC)
		
	end if
end repeat

-- =========================================================
-- =========================================================
-- SubroutinesHandlers
-- =========================================================



on Clipper(T, FinPos, ClipName, NAC)
	tell application "iTunes"
		set TrkName to name of current track
		set PL to current playlist
		set start of current track to T
		set finish of current track to FinPos
		set Re to convert current track
		set yy to location of item 1 of Re as text
		set start of current track to 0
		set gg to time of current track
	end tell
	set hh to ""
	set hh to calctime(gg)
	tell application "iTunes" to set finish of current track to hh
	set FN to GetiTunesTrack(yy)
	tell application "iTunes"
		set te to add yy to playlist NAC
		play yy
		pause track
		set name of current track to ClipName
		play track TrkName
	end tell
	return 0
end Clipper



on GetiTunesTrack(FileNameText)
	set AppleScript's text item delimiters to {":"}
	set delimitedList to every text item of FileNameText
	set fname to last item in delimitedList
	set AppleScript's text item delimiters to {"."}
	set delimitedList to every text item of fname
	set fname to first item in delimitedList
	set AppleScript's text item delimiters to {""}
	return fname
end GetiTunesTrack



on calctime(totalSeconds)
	set TS to totalSeconds as string
	set AppleScript's text item delimiters to {":"}
	set TS to every text item of TS
	set NextItem to 1
	if number of items in TS > 2 then
		set hHours to first item of TS as integer
		set NextItem to 2
	end if
	
	set mMinutes to item NextItem in TS as integer
	set sSeconds to last item in TS
	set tmin to mMinutes * 60
	set tHours to hHours * 3600
	return (tmin + tHours + sSeconds)
	set AppleScript's text item delimiters to {""}
end calctime
